package com.bohuikeji.frame.module.admin.utils;


import org.apache.commons.lang.StringUtils;
import org.krysalis.barcode4j.HumanReadablePlacement;
import org.krysalis.barcode4j.impl.AbstractBarcodeBean;
import org.krysalis.barcode4j.impl.code128.Code128Bean;
import org.krysalis.barcode4j.output.bitmap.BitmapCanvasProvider;
import org.krysalis.barcode4j.tools.UnitConv;

import java.awt.image.BufferedImage;
import java.io.*;

public class BarcodeUtil {
    /**
     * 生成文件
     *
     * @param msg
     * @param path
     * @return
     */
    public static File generateFile(String msg, String path) {
        File file = new File(path);
        try {
            generate(msg, new FileOutputStream(file),5,10);
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        }
        return file;
    }

    /**
     * 生成字节
     *
     * @param msg
     * @return
     */
    public static byte[] generate(String msg,double width,double height) {
        ByteArrayOutputStream ous = new ByteArrayOutputStream();
        generate(msg, ous,width,height);
        return ous.toByteArray();
    }

    /**
     * 生成到流
     *
     * @param msg
     * @param ous
     */
    public static void generate(String msg, OutputStream ous,double width,double height) {
        if (StringUtils.isEmpty(msg) || ous == null) {
            return;
        }

        AbstractBarcodeBean bean = createCodeBean(width,height);
        // 精细度
        final int dpi = 180;
        String format = "image/png";
        try {

            // 输出到流
            BitmapCanvasProvider canvas = new BitmapCanvasProvider(ous, format, dpi,
                    BufferedImage.TYPE_BYTE_BINARY, false, 0);
            System.out.println(canvas);
            //canvas.deviceFillRect(0,0,10,10);
            //canvas.deviceCenteredText("ssss",5,5,5,null,5);
            //canvas.deviceText("哈哈哈",10,20,30,"Symbol",12, TextAlignment.TA_CENTER);
            // 生成条形码
            bean.generateBarcode(canvas, msg);

            // 结束绘制
            canvas.finish();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    /*public static void main(String[] args) {
        String msg = "123456789";
        String path = "barcode.png";
        generateFile(msg, path);
    }*/

    private static AbstractBarcodeBean createCodeBean(double width, double height){
        Code128Bean bean = new Code128Bean();
        // 设置文本位置（包括是否显示）
        bean.setMsgPosition(HumanReadablePlacement.HRP_NONE);
        bean.setModuleWidth(width);
        bean.setHeight(height);
        bean.doQuietZone(false);
        return bean;

    }

}
